#ifndef STACK_H
#define STACK_H

#include <assert.h>

#include <vector>

/**
 * First template parameter is the datatype of the elements to be stored.
 * Second template parameter is the maximum stack size.
 */
template <typename T, int N>
class Stack {
 private:
        // Underlying array
        T stackArray[N];

        int topLevel;

 public:
        // Constructor
        Stack() {
            // TODO: initializations
        }

        // Destructor
        ~Stack() {
            // TODO: delete previously allocated stuff (if any)
        }

        // Adds an element on top of the stack.
        void push(T x) {
            // TODO: implement
        }

        // Removes the top element of the stack.
        void pop() {
            // TODO: implement
        }

        // Retrieves the top value stored in the stack.
        T peek() {
            // TODO: implement
        }

        // Checks if the stack contains any elements.
        bool isEmpty() {
            // TODO: implement
        }

        // Returns the number of elements currently stored in the stack.
        int size() {
            // TODO: implement
        }

        template <typename U, int M>
        friend std::ostream& operator<<(std::ostream& os, Stack<U, M>& stack);
};

template <typename T, int N>
std::ostream& operator<<(std::ostream& os, Stack<T, N>& stack) {
    os << "Bottom -> Top: ";
    std::vector<T> aux;

    while (!stack.isEmpty()) {
        aux.push_back(stack.peek());
        stack.pop();
    }

    for (int i = aux.size() - 1; i >= 0; i--) {
        os << aux[i] << " ";
        stack.push(aux[i]);
    }

    return os;
}

#endif  // STACK_H
